import { PRE_GAME, PRE_ROUND, IN_ROUND, POST_ROUND, POST_GAME } from "./GameState";
import { createStore } from "../store";

export const [
  {
    useGameId,
    usePlayerName,
    useLastRound,
    useGameJoined,
    useGameState,
  },
  dispatch,
  selector,
] = createStore({
  gameId: null,
  playerName: null,
  lastRound: null,
  gameJoined: false,
  gameState: PRE_GAME,
}, {
  setGameId: gameId => ({ gameId }),
  setPlayerName: playerName => ({ playerName }),
  joinGame: () => ({ gameJoined: true }),
  resetGame: () => ({ gameJoined: false, gameState: PRE_GAME }),
  startGame: () => ({ gameState: PRE_ROUND }),
  startRound: () => ({ gameState: IN_ROUND }),
  endRound: lastRound => ({ lastRound, gameState: POST_ROUND }),
  endGame: () => ({ gameState: POST_GAME }),
});